landscape-package-changer crashed with io.UnsupportedOperation in pulse(): fileno

Bug #1758529 reported by Adam Collard
18
This bug affects 2 people
Affects Status Importance Assigned to Milestone
Landscape Client
Undecided
Simon Poirier
landscape-client (Ubuntu)
Medium
Unassigned
Bionic
Undecided
Simon Poirier
Disco
Undecided
Unassigned
Eoan
Medium
Simon Poirier

Bug Description

[Impact]

 * landscape-package-changer will output stack traces when executed
   with python3. This adds noise in the logs and confuse apport into
   thinking there was a crash, even though the error does not affect
   functionality.

 * The activity log for package operations will also show errors.

 * The patch overrides python-apt reporting of progress, as
   landscape-package-changer is never executed from a terminal.

[Test Case]

 * register landscape-client and wait for packages to be reported.

 * trigger a package installation from the landscape server.

 * check /var/log/landscape/manager.log for Package changer warnings

[Regression Potential]

 * The change is trivially simple.

 * The changed code path is only used by python-apt progress reporting.
   Since landscape-package-changer does not rely on it and is able
   to continue, other errors would likely have the same fate: that is
   crashing the progress reporting thread and continuing.

[Original Description]

Crash in the background

ProblemType: Crash
DistroRelease: Ubuntu 18.04
Package: landscape-client 18.01-0ubuntu2
ProcVersionSignature: Ubuntu 4.15.0-12.13-generic 4.15.7
Uname: Linux 4.15.0-12-generic x86_64
NonfreeKernelModules: nvidia_modeset nvidia
ApportVersion: 2.20.8-0ubuntu10
Architecture: amd64
Date: Sat Mar 24 07:05:34 2018
ExecutablePath: /usr/bin/landscape-package-changer
InstallationDate: Installed on 2015-07-04 (994 days ago)
InstallationMedia: Ubuntu 15.04 "Vivid Vervet" - Release amd64 (20150422)
InterpreterPath: /usr/bin/python3.6
ProcCmdline: /usr/bin/python3 /usr/bin/landscape-package-changer --quiet
ProcEnviron:
 LANGUAGE=en_GB:en
 PATH=(custom, no user)
 LANG=en_GB.UTF-8
Python3Details: /usr/bin/python3.6, Python 3.6.5rc1, python3-minimal, 3.6.4-1
PythonArgs: ['/usr/bin/landscape-package-changer', '--quiet']
PythonDetails: /usr/bin/python2.7, Python 2.7.14+, python-minimal, 2.7.14-4
SourcePackage: landscape-client
Title: landscape-package-changer crashed with io.UnsupportedOperation in pulse(): fileno
Traceback:
 Traceback (most recent call last):
   File "/usr/lib/python3/dist-packages/apt/progress/text.py", line 164, in pulse
     not os.isatty(self._file.fileno())):
 io.UnsupportedOperation: fileno
UpgradeStatus: Upgraded to bionic on 2018-03-15 (8 days ago)
UserGroups:

Related branches

Revision history for this message
Adam Collard (adam-collard) wrote :
tags: removed: need-duplicate-check
Changed in landscape-client (Ubuntu):
importance: Undecided → Medium
Simon Poirier (simpoir)
tags: added: low-hanging-fruit
Simon Poirier (simpoir)
Changed in landscape-client:
status: New → Confirmed
Revision history for this message
Simon Poirier (simpoir) wrote :
Changed in landscape-client:
assignee: nobody → Simon Poirier (simpoir)
status: Confirmed → In Progress
Simon Poirier (simpoir)
Changed in landscape-client:
status: In Progress → Fix Committed
Revision history for this message
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in landscape-client (Ubuntu):
status: New → Confirmed
Changed in python-apt (Ubuntu):
status: New → Confirmed
Simon Poirier (simpoir)
Changed in python-apt (Ubuntu):
status: Confirmed → Invalid
Simon Poirier (simpoir)
Changed in python-apt (Ubuntu Bionic):
status: New → Invalid
Changed in python-apt (Ubuntu Disco):
status: New → Invalid
Simon Poirier (simpoir)
Changed in landscape-client (Ubuntu Bionic):
status: New → Confirmed
Changed in landscape-client (Ubuntu Disco):
status: New → Confirmed
Simon Poirier (simpoir)
description: updated
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package landscape-client - 19.12-0ubuntu1

---------------
landscape-client (19.12-0ubuntu1) focal; urgency=medium

  * New upstream release 19.12:
    - Modernized packaging.
    - Added support for python-apt 1.9
    - Converted init script to systemd service.
    - Set default value if data_path is missing. (LP: #1728681)
    - Sysinfo: add support for multiple IPv6 addresses per interface.
      (LP: #829379)
    - Clear hash id database on package resync. (LP: #1616116)
    - Permit environments containing unicode chars for script execution.
      (LP: #1765518)
    - Set LANG in sysinfo wrapper. (LP: #1780071)
    - Avoid leaking memory through unused twisted logs. (LP: #1685885)
    - Handle unicode apt-sources-replace (LP: #1771443)
    - Add simfs to the whitelist of watched file-systems (LP: #1499104)
    - Return non-blank message when tasks already performed. (LP: #928933)
    - Overrid apt progress pulse(). (LP: #1758529)
    - Improvements on vm_info detection (LP: #1754073) (LP: #1799843)
      (LP: #1828217)
    - Remove the landscape url from motd output by removing LandscapeLink
      from the list of default landscape-sysinfo plugins. (LP: #1753936)

 -- Simon Poirier <email address hidden> Wed, 04 Dec 2019 14:12:24 +0000

Changed in landscape-client (Ubuntu):
status: Confirmed → Fix Released
Eric Desrochers (slashd)
Changed in landscape-client (Ubuntu Disco):
status: Confirmed → Won't Fix
Changed in landscape-client (Ubuntu Eoan):
assignee: nobody → Simon Poirier (simpoir)
Changed in landscape-client (Ubuntu Bionic):
assignee: nobody → Simon Poirier (simpoir)
status: Confirmed → In Progress
Changed in landscape-client (Ubuntu Eoan):
status: Confirmed → In Progress
Revision history for this message
Eric Desrochers (slashd) wrote :

Sponsored for B/E

Thanks Simon !

Eric Desrochers (slashd)
information type: Private → Public
Revision history for this message
Łukasz Zemczak (sil2100) wrote : Please test proposed package

Hello Adam, or anyone else affected,

Accepted landscape-client into eoan-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/landscape-client/18.01-0ubuntu9.2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-eoan to verification-done-eoan. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-eoan. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in landscape-client (Ubuntu Eoan):
status: In Progress → Fix Committed
tags: added: verification-needed verification-needed-eoan
Changed in landscape-client (Ubuntu Bionic):
status: In Progress → Fix Committed
tags: added: verification-needed-bionic
Revision history for this message
Łukasz Zemczak (sil2100) wrote :

Hello Adam, or anyone else affected,

Accepted landscape-client into bionic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/landscape-client/18.01-0ubuntu3.5 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-bionic to verification-done-bionic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-bionic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

tags: added: verification-done-bionic
removed: verification-needed-bionic
Revision history for this message
Chris Johnston (cjohnston) wrote :

On both bionic and eoan I installed postgres packages from Landscape with both the current version and the proposed version of Landscape client. Errors were seen with the current version and they were gone in the proposed version.

tags: added: verification-done-eoan
removed: verification-needed-eoan
Mathew Hodson (mhodson)
no longer affects: python-apt (Ubuntu)
no longer affects: python-apt (Ubuntu Bionic)
no longer affects: python-apt (Ubuntu Disco)
no longer affects: python-apt (Ubuntu Eoan)
tags: removed: verification-needed
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package landscape-client - 18.01-0ubuntu9.2

---------------
landscape-client (18.01-0ubuntu9.2) eoan; urgency=medium

  * d/p/apt-pulse-1758529.patch:
    Override the apt progress pulse (LP: #1758529)

 -- Simon Poirier <email address hidden> Thu, 20 Feb 2020 17:25:20 +0000

Changed in landscape-client (Ubuntu Eoan):
status: Fix Committed → Fix Released
Revision history for this message
Łukasz Zemczak (sil2100) wrote : Update Released

The verification of the Stable Release Update for landscape-client has completed successfully and the package is now being released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package landscape-client - 18.01-0ubuntu3.5

---------------
landscape-client (18.01-0ubuntu3.5) bionic; urgency=medium

  * d/p/apt-pulse-1758529.patch:
    Override the apt progress pulse (LP: #1758529)

 -- Simon Poirier <email address hidden> Thu, 20 Feb 2020 17:35:22 +0000

Changed in landscape-client (Ubuntu Bionic):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers